export declare class AstroComponent {
    private htmlParts;
    private expressions;
    constructor(htmlParts: TemplateStringsArray, expressions: any[]);
    [Symbol.iterator](): Generator<Promise<any>, void, unknown>;
}
export declare function render(htmlParts: TemplateStringsArray, ...expressions: any[]): Promise<AstroComponent>;
export interface AstroComponentFactory {
    (result: any, props: any, slots: any): ReturnType<typeof render>;
    isAstroComponentFactory?: boolean;
}
export declare const createComponent: (cb: AstroComponentFactory) => AstroComponentFactory;
export declare const renderSlot: (result: any, slotted: string, fallback?: any) => Promise<any>;
export declare const renderComponent: (result: any, displayName: string, Component: unknown, _props: Record<string | number, any>, slots?: any) => Promise<string>;
export declare const addAttribute: (value: any, key: string) => string;
export declare const spreadAttributes: (values: Record<any, any>) => string;
export declare const defineStyleVars: (astroId: string, vars: Record<any, any>) => string;
export declare const defineScriptVars: (vars: Record<any, any>) => string;
